//
//  baseTableViewCell.m
//  双子星云手机
//
//  Created by xd h on 2024/10/23.
//

#import "baseTableViewCell.h"

@implementation baseTableViewCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    
    if (self)
    {
        [self drawView];
    }
    
    return self;
}

- (void)drawView
{
    _cellBgView = [[UIView alloc] init];
    [self.contentView addSubview:_cellBgView];
    _cellBgView.backgroundColor = [UIColor whiteColor];
    [_cellBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0.f);
        make.top.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.right.mas_equalTo(0);
    }];
    
    
    /*图片*/
    _mImageView = [[UIImageView alloc] init];
    [_mImageView setBackgroundColor:[UIColor clearColor]];
    //_mImageView.image = [UIImage imageNamed:@""];
    [_cellBgView  addSubview:_mImageView];
    [_mImageView setContentMode:(UIViewContentModeScaleAspectFit)];
    [_mImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15);
        make.width.mas_equalTo(42);
        make.height.mas_equalTo(42);
        make.centerY.equalTo(self.mas_centerY);
    }];
    
    
    /**标题*/
    _titleLabel = [[UILabel alloc] init];
    [_cellBgView addSubview:_titleLabel];
    _titleLabel.font = [UIFont systemFontOfSize:12.f];
    _titleLabel.numberOfLines = 2;
    _titleLabel.lineBreakMode = NSLineBreakByTruncatingMiddle;
    [_titleLabel setTextColor:HW666666Color];
    [_titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(_mImageView.mas_right).offset(5.f);
        //make.right.equalTo(self.mas_centerX).offset(5.f);
        make.height.equalTo(_mImageView.mas_height);
        make.top.equalTo(_mImageView.mas_top);
    }];
    
    /**副标题*/
    _contentLabel = [[UILabel alloc] init];
    [_cellBgView addSubview:_contentLabel];
    _contentLabel.font = [UIFont systemFontOfSize:14.f];
    _contentLabel.lineBreakMode = NSLineBreakByTruncatingMiddle;
    [_contentLabel setTextAlignment:(NSTextAlignmentRight)];
    [_contentLabel setTextColor:HW0A132BColor];
    [_contentLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(-20);
        //make.left.mas_equalTo(_titleLabel.mas_left);
        make.height.equalTo(_mImageView.mas_height);
        make.top.equalTo(_titleLabel.mas_top);
    }];
    
    /*右侧箭头*/
    _rightImage = [[UIImageView alloc] init];
    _rightImage.hidden = YES;
    [_rightImage setBackgroundColor:[UIColor clearColor]];
    [_rightImage setImage:[UIImage imageNamed:@"cell_right_access"]];
    [_cellBgView addSubview:_rightImage];
    [_rightImage mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(20);
        make.right.mas_equalTo(-20.f);
        make.height.mas_equalTo(20);
        make.centerY.equalTo(_cellBgView.mas_centerY);
    }];
    
}

- (void)setShowLeftImageType:(BOOL)showLeftImageType
{
    //默认显示
    if(showLeftImageType) return;
    
    /**标题*/
    [_titleLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15);
        //make.right.equalTo(self.mas_centerX).offset(5.f);
        make.height.equalTo(_mImageView.mas_height);
        make.top.equalTo(_mImageView.mas_top);
    }];
    
}

- (void)setShowRightImageType:(BOOL)showRightImageType
{
  
    if(showRightImageType){
        _rightImage.hidden = NO;
        [_contentLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(_rightImage.mas_left).offset(-5);
            //make.left.mas_equalTo(_titleLabel.mas_left);
            make.height.equalTo(_mImageView.mas_height);
            make.top.equalTo(_titleLabel.mas_top);
        }];
    }
    else{
        _rightImage.hidden = YES;
        [_contentLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(_rightImage.mas_right).offset(0);
            //make.left.mas_equalTo(_titleLabel.mas_left);
            make.height.equalTo(_mImageView.mas_height);
            make.top.equalTo(_titleLabel.mas_top);
        }];
    }
    
}
@end
