//
//  previewAudioPortraitTopMoreView.m
//  Private-X
//
//  Created by xd h on 2024/7/15.
//

#import "previewAudioPortraitTopMoreView.h"

@implementation previewAudioPortraitTopMoreView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
    self.backgroundColor = [UIColor hwColor:@"#000000" alpha:0.6];
    [self drawAnyView];
    
    return self;
}

-(void)drawAnyView
{
    //大按钮响应
    UIButton *bigRightButton = [[UIButton alloc] init];
    bigRightButton.tag = 1;
    [bigRightButton addTarget:self action:@selector(didClickButtonFun:) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:bigRightButton];
    //bigRightButton.backgroundColor= [UIColor greenColor];
    
    [bigRightButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(0);
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
    }];
    
    UIView *whiteBgView = [[UIView alloc] init];
    whiteBgView.backgroundColor = [UIColor whiteColor];
    [self addSubview:whiteBgView];
    whiteBgView.layer.cornerRadius = 8;
    whiteBgView.layer.masksToBounds = YES;
    
    [whiteBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(105);
        make.right.mas_equalTo(-16);
        make.width.mas_equalTo(112);
        make.height.mas_equalTo(170);
        //make.height.mas_equalTo(150);
    }];
    
    NSArray *butImageArr = @[@"edit_download_icon",@"edit_del_icon",@"edit_details_icon"];
    
    NSArray *butTextArr = @[NSLocalizedString(@"my_set_no_File_download",nil),
                            NSLocalizedString(@"File_upload_Record_delete",nil),
                            NSLocalizedString(@"NAS_edit_details_title",nil)];
    

    CGFloat butHeight = 50.0;
   
    
    for (int i=0; i<butImageArr.count; i++) {
        
        UIButton *but = [[UIButton alloc] init];
        but.tag = 10+i;
        [but addTarget:self action:@selector(didClickButtonFun:) forControlEvents:UIControlEventTouchUpInside];
        NSString *butTitle = [[NSString alloc] initWithFormat:@"   %@",butTextArr[i]];
        [but setImage:[UIImage imageNamed:butImageArr[i]] forState:UIControlStateNormal];
        [but setTitle:butTitle forState:UIControlStateNormal];
        [but setTitleColor:[UIColor hwColor:@"#0A132B"] forState:UIControlStateNormal];
        but.titleLabel.font = [UIFont systemFontOfSize:14.0];
        [whiteBgView addSubview:but];
        
        [but mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(0);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(butHeight);
            make.top.mas_equalTo(10 + butHeight*i);
        }];
        
//        if(i != butImageArr.count -1){
//            UIView *lineV = [UIView new];
//            lineV.backgroundColor = [UIColor hwColor:@"#F3F5F9"];
//            [whiteBgView addSubview:lineV];
//
//            [lineV mas_makeConstraints:^(MASConstraintMaker *make) {
//                make.left.mas_equalTo(8);
//                make.right.mas_equalTo(-8);
//                make.height.mas_equalTo(0.5);
//                make.top.mas_equalTo(butHeight*(i+1));
//            }];
//        }
        
    }
}

#pragma mark 按钮事件
- (void)didClickButtonFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    HLog(@"%ld",tag);
    
    [self removeFun];
    
    if(tag == 1){
        return;
    }
    
    if(_didClickButtonFun){
        _didClickButtonFun(tag);
    }
}

- (void)removeFun
{
    [self removeFromSuperview];
}
@end

