//
//  customDownloadCacheManager.h
//  Private-X
//
//  Created by xd h on 2024/7/1.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

#define KCustomFullPath NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0]
#define KCustomFullDirector  [self getFullDirector]
#define KCustomDownloadDirector  @"customDownload"

@interface customDownloadCacheManager : NSObject

/**  查询当前文件下载了多少 */
+ (int64_t)getFileSizeWithURL:(NSString *)url;

/**  删除某个文件 */
+ (BOOL)deleteFileWithUrl:(NSString *)url;

/**  清理所有下载文件及下载信息 */
+ (BOOL)clearDisks;

/**  取消所有当前下载的文件 清理内存缓存的数据 */
+ (BOOL)clearMemory;

/**  取消所有当前下载的文件 删除磁盘所有的下载 清理内存缓存的数据 */
+ (BOOL)clearMemoryAndDisk;

+ (NSString *)getFullDirector;

/**  上传的fullPath 是不能用的 要改新的*/
+ (NSString *)getFullPathByOldFullPath:(NSString*)fullPath;

@end

NS_ASSUME_NONNULL_END
