//
//  nasDownloadManager.h
//  双子星云手机
//
//  Created by xd h on 2024/8/5.
//

#import <Foundation/Foundation.h>
#import "customDownloadOperation.h"
NS_ASSUME_NONNULL_BEGIN

/** 下载中通知 */
#define  nasDownloadTaskExeing        @"nasDownloadTaskExeing"
/** 下载失败通知 */
#define  nasDownloadTaskExeError      @"nasDownloadTaskExeError"
/** 下载完成通知 */
#define  nasDownloadTaskExeEnd        @"nasDownloadTaskExeEnd"

@interface nasDownloadManager : NSObject

@property(nonatomic,strong) NSString *uid;//用户id 用来创建文件夹路径 防止不要用户的缓存关联
@property(nonatomic,assign) NSInteger maxDownLoadCount;//默认一个
@property(nonatomic,assign) BOOL isDownLoadIngType;//

/** 实例化对象（单例） */
+ (instancetype)shareManager;

#pragma mark - 队列中的任务进行操作

/** 添加要下载的 网络连接  */
- (void)addDownloadWithURLs:(NSArray *)urls;
//在添加下载地址后 启动下载
//- (void)beginDownload;

/** 开始任务（不会自动添加任务，列队中没有就直接返回） 后续改为会自动添加任务 */
- (void)startDownLoadWithUrl:(NSString *)url;

/** 暂停任务（暂停下载url内容的任务） */
- (void)supendDownloadWithUrl:(NSString *)url;

/** 暂停当前所有的下载任务 下载任务不会从列队中删除 */
- (void)suspendAllDownloadTask;

/** 删除任务（删除下载url内容的任务） */
- (void)deleteDownloadWithUrl:(NSString *)url;
@end
NS_ASSUME_NONNULL_END
