//
//  nasUploadFileManager.h
//  Private-X
//
//  Created by xd h on 2024/8/7.
//

#import <Foundation/Foundation.h>
#import "uploadFileManager.h"
#import "frpUploadModel.h"
#import "frpFileExistModel.h"
#import "nasMixUploadManager.h"
#import "recordFileModel.h"

NS_ASSUME_NONNULL_BEGIN

#define nasUpLoadFile_tableName [[NSString alloc] initWithFormat:@"upLoadFile_tableName_%@",ksharedAppDelegate.DeviceThirdIdMod.data.sn]

@interface nasUploadFileManager : NSObject
+(instancetype)shareInstance;
//数据库数据
@property (atomic, strong) NSMutableArray * _Nullable databaseArr;
@property (atomic, strong) NSMutableArray * _Nullable uploadingArr;

@property (nonatomic, assign) BOOL  isSuspendType;
//@property (nonatomic, assign) BOOL  isUploadIngType;//弃用
@property (nonatomic, assign) BOOL  isNewAddTaskType;
//@property (nonatomic, assign) NSInteger  curUploadModelNumbers;
@property (nonatomic, assign) NSInteger  reUploadIngSelectIndex;
@property (nonatomic, assign) BOOL  needToReUploadTaskType;//

#pragma mark 读取数据库数据
- (void)getDataInDatabaseFun:(BOOL)isReGet complete:(custom_complete_Arr)complete;

//把TZAssetModel 转成 我们需要上传的model
- (void)handlTZAssetModelToUploadFileDataFunBy:(NSMutableArray*)indexPathsForSelectedItems complete:(custom_complete_Arr)complete;

//把url 转成 我们需要上传的model
- (void)handlUrlToUploadFileDataFunBy:(NSArray*)UrlArr complete:(custom_complete_Arr)complete;

//把录音filePath 转成 我们需要上传的model
- (void)handlToRecorUploadFileDataFunBy:(NSArray*)recordFileArr complete:(custom_complete_Arr)complete;

//删除本地数据库记录
- (void)deleteUploadFileRecordBy:(NSMutableArray *)delArr withDelCache:(BOOL)isDelCache complete:(custom_complete_B)complete;

- (void)checkHadUploadTaskWithComplete:(custom_complete_B)complete;

//文件重新上传
- (void)reUploadFileFunBy:(NSMutableArray*)Arr withAll:(BOOL)isAllType;
//暂停上传 当 isSuspendAll为NO时候 传指定暂停哪一个
- (void)suspendUploadFileFun:(BOOL)isSuspendAll withModel:(uploadFileDataModel*)model;
//网络失败后任务暂时保存
- (void)saveUploadingTaskByNetWorkErrorFun;
//重新上传网络失败的任务
- (void)reUploadFileFunByNetWork;
@end

NS_ASSUME_NONNULL_END
