//
//  audioPlayListManager.h
//  双子星云手机
//
//  Created by xd h on 2024/7/15.
//

#import <Foundation/Foundation.h>
#import "lastFileModel.h"
#import "audioPlayDownloadManager.h"

NS_ASSUME_NONNULL_BEGIN

#define KaudioPlayListDirector  @"audioPlayList"
#define KaudioPlayListkey  @"audioPlayListKey"

@interface audioPlayListManager : NSObject
@property(nonatomic,strong) NSString *uid;//用户id 用来创建文件夹路径 防止不要用户的缓存关联
@property (nonatomic, strong) NSMutableDictionary * _Nullable audioPlayPList;
@property (nonatomic, strong) NSMutableArray * _Nullable audioPlayListArr;


/** 实例化对象（单例） */
+ (instancetype)shareManager;

/**  增加配置信息 */
- (BOOL)saveFileInfoWith:(lastFileModel *)lastFileMod with:(NSString*)fullPath;
/**  删除配置信息 */
- (BOOL)deleteFileInfoWithUrl:(NSString *)fullPath;

- (NSString*)getAudioCacheFullPathBy:(NSString*)name;

//df准备播放是下载
- (void)beginToDownloadByUrl:(NSString*)url;

/**  更新下载完成 */
- (void)changeFileToDonewith:(NSString*)url;

/**  检测是否下载完成 */
- (NSString*)checkFileToDownloadDonewith:(NSString*)url;
@end

NS_ASSUME_NONNULL_END
