//
//  AudioRecorderManager.h
//  双子星云手机
//
//  Created by xd h on 2025/3/28.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface AudioRecorderManager : NSObject<AVAudioRecorderDelegate>

@property (nonatomic, strong) AVAudioRecorder *audioRecorder;
@property (nonatomic, strong) AVAudioPlayer *audioPlayer;
@property (nonatomic, copy) NSString *recordedFilePath;

@property (nonatomic, copy) NSString *curRecordName;

+ (instancetype)sharedManager;

- (void)startRecording;
- (void)stopRecording;
- (void)playRecording;
- (void)stopPlaying;
- (BOOL)isRecording;
- (BOOL)isPlaying;


@end

NS_ASSUME_NONNULL_END
