//
//  Header.h
//  WebRTCDemo
//
//  Created by 朱珠令 on 2024/5/7.
//

#ifndef ASignalChannel_h
#define ASignalChannel_h

#import <Foundation/Foundation.h>
#import <WebRTC/RTCMacros.h>

typedef void (^responseBlock)(int status, NSString * _Nullable msg);

RTC_OBJC_EXPORT
@protocol RTC_OBJC_TYPE(ANatsSignalChannelDelegate) <NSObject>

-(void) connectionDisconnect;

-(void) connectionErrorStatus:(int)status;

-(void)asyncSignalResponse:(nonnull NSString*)msg;

@end


RTC_OBJC_EXPORT
@interface RTC_OBJC_TYPE(ANatsSignalChannel) : NSObject

@property (nonatomic, weak) _Nullable id <ANatsSignalChannelDelegate> delegate;

+ (_Nonnull instancetype)shardInstance;

- (int)connectSignalWithUrl:(nonnull NSString *)url sn:(nonnull NSString *)sn name:(nonnull NSString *)name; 

- (int)closeSignal;

- (int)sendAsyncSignalData:(nonnull NSString *)data;

- (int)sendSyncSignalData:(nonnull NSString *)data timeout:(int)timeout/*ms*/ responseBlock:(responseBlock _Nullable )responseBlock;

@end

#endif /* ASignalChannel_h */
