//
//  webRtcMsgModel.h
//  Private-X
//
//  Created by xd h on 2024/9/2.
//

#import "SuperModel.h"

NS_ASSUME_NONNULL_BEGIN

@interface webRtcMsgSignallingModel : SuperModel //信令服务对象 (推流)
@property (nonatomic, copy) NSString *port;//端口
@property (nonatomic, copy) NSString *domainName;//地址
@end

@interface webRtcMsgTurnModel : SuperModel //turn服务对象 （ice）
@property (nonatomic, copy) NSString *port;//端口
@property (nonatomic, copy) NSString *domainName;//地址
@end

@interface webrtcServerModel : SuperModel //1.4.4 所有的信息
@property (nonatomic, copy) NSString *signallingPort;//端口
@property (nonatomic, copy) NSString *signallingDomainName;//地址
@property (nonatomic, copy) NSString *signallingIp;//需要用的ip

@property (nonatomic, copy) NSString *turnPort;//端口
@property (nonatomic, copy) NSString *turnDomainName;//地址
@property (nonatomic, copy) NSString *turnIp;//需要用的ip

@property (nonatomic, assign) CGFloat delayedms;// ping的延时毫秒数

@end

@protocol webrtcServerModel;
@interface webRtcMsgDataModel : SuperModel

@property (nonatomic, copy) NSString *sn;//SN
@property (nonatomic, copy) NSString *uniqueIdentifier;//唯一标识符
@property (nonatomic, copy) NSString *cpuSerialNum;//CPU 序列号
@property(nonatomic, strong) webRtcMsgSignallingModel*signalling;
@property(nonatomic, strong) webRtcMsgTurnModel*turn;

@property (nonatomic, strong) NSArray<webrtcServerModel>* webrtcServerList;

//自定义字段
@property (nonatomic, assign) BOOL isPingDoneType;// 是否ping完成 所有IP
@end
 
@interface webRtcMsgModel : SuperModel
@property(nonatomic, strong) webRtcMsgDataModel*data;
@end

NS_ASSUME_NONNULL_END
