//
//  webRtcPlayerBottomContrView.m
//  双子星云手机
//
//  Created by xd h on 2024/9/5.
//

#import "webRtcPlayerBottomContrView.h"

@interface webRtcPlayerBottomContrView ()
{
    UIButton *mueBtn;
    UIButton *homeBtn;
    UIButton *backBtn;
    
    UIButton *showHomeBtn;
}

@property (nonatomic,assign) BOOL isLan;//是否是横屏状态

@end

@implementation webRtcPlayerBottomContrView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
    if (self){
        [self setBackgroundColor:[UIColor clearColor]];
        [self initAddSubViewForBottomContrView];
    }
    
    return self;
}

- (void)initAddSubViewForBottomContrView{
    /*第一个app菜单*/
    UIImage  *mueBtnImage = [UIImage imageNamed:@"houtai_icon"];
    mueBtn = [[UIButton alloc] init];
    mueBtn.tag = 1;
    [mueBtn setBackgroundColor:[UIColor clearColor]];
    [mueBtn addTarget:self
               action:@selector(didClickButtonFun:)
     forControlEvents:(UIControlEventTouchUpInside)];
    [mueBtn setImage:mueBtnImage forState:(UIControlStateNormal)];
    [mueBtn setImageEdgeInsets:(UIEdgeInsetsMake(6.f, 6.f, 6.f, 6.f))];
    [self addSubview:mueBtn];
    
    /*第二个home键*/
    UIImage  *homeBtnImage = [UIImage imageNamed:@"home_icon"];
    homeBtn = [[UIButton alloc] init];
    homeBtn.tag = 2;
    [homeBtn setBackgroundColor:[UIColor clearColor]];
    [homeBtn addTarget:self
                action:@selector(didClickButtonFun:)
      forControlEvents:(UIControlEventTouchUpInside)];
    [homeBtn setImage:homeBtnImage forState:(UIControlStateNormal)];
    [homeBtn setImageEdgeInsets:(UIEdgeInsetsMake(6.f, 6.f, 6.f, 6.f))];
    [self addSubview:homeBtn];
    
    /*第三个返回键*/
    UIImage  *backBtnImage = [UIImage imageNamed:@"fanhui_you_icon"];
    //UIImage  *backBtnImage = [UIImage imageNamed:@"fanhui_you_icon"];
    backBtn = [[UIButton alloc] init];
    backBtn.tag = 3;
    [backBtn setBackgroundColor:[UIColor clearColor]];
    [backBtn addTarget:self
                action:@selector(didClickButtonFun:)
      forControlEvents:(UIControlEventTouchUpInside)];
    [backBtn setImage:backBtnImage forState:(UIControlStateNormal)];
    [backBtn setImageEdgeInsets:(UIEdgeInsetsMake(6.f, 6.f, 6.f, 6.f))];
    [self addSubview:backBtn];
    //测试说图片方向反了
    //backBtn.imageView.transform = CGAffineTransformMakeRotation(M_PI);
    
    /*第四个隐藏显示键*/
    UIImage  *showBtnImage = [UIImage imageNamed:@"showOrhide_home_icon"];
    showHomeBtn = [[UIButton alloc] init];
    showHomeBtn.tag = 4;
    [showHomeBtn setBackgroundColor:[UIColor clearColor]];
    [showHomeBtn addTarget:self action:@selector(didClickButtonFun:) forControlEvents:(UIControlEventTouchUpInside)];
    [showHomeBtn setImage:showBtnImage forState:(UIControlStateNormal)];
    [showHomeBtn setImageEdgeInsets:(UIEdgeInsetsMake(6.f, 6.f, 6.f, 6.f))];
    [self addSubview:showHomeBtn];
}

#pragma mark 更新按钮区域
- (void)updateFrameFunByIsLan:(BOOL)isLan
{
    _isLan = isLan;
    
    HLog(@"更新推流页的底部区域 isLan:%d",isLan)
    if(isLan){
        
        [homeBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(self.mas_centerY);
            make.width.and.height.mas_equalTo(40.f);
            make.left.mas_equalTo(0);
        }];
        
        [showHomeBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.top.mas_equalTo(10.f);
            make.width.and.height.mas_equalTo(40.f);
            make.left.mas_equalTo(0);
        }];
        
        [backBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            //make.top.mas_equalTo(80.f);
            make.bottom.mas_equalTo(-80.f);
            make.width.and.height.mas_equalTo(40.f);
            make.left.mas_equalTo(0);
        }];
        
        [mueBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            //make.bottom.mas_equalTo(-80.f);
            make.top.mas_equalTo(80.f);
            make.width.and.height.mas_equalTo(40.f);
            make.left.mas_equalTo(0);
        }];
    }
    else{
        [mueBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-80.f);
            make.width.and.height.mas_equalTo(40.f);
            make.top.mas_equalTo(0);
        }];

        [homeBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.mas_centerX);
            make.width.and.height.mas_equalTo(40.f);
            make.top.mas_equalTo(0);
        }];

        [backBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(80.f);
            make.width.and.height.mas_equalTo(40.f);
            make.top.mas_equalTo(0);
        }];
        
        [showHomeBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.mas_equalTo(-10.f);
            make.width.and.height.mas_equalTo(40.f);
            make.top.mas_equalTo(0);
        }];
    }
    
    
    //[self getPlayerBottomNavShowOrHidefun];
    
    [self setShowOrHideBottomButtonsFunBy:showHomeBtn.selected];
}

- (void)didClickButtonFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    if(_didClickButtonFun){
        _didClickButtonFun(tag);
    }
    
    if(tag == 4){
        [self showOrHideHomeButtomFun:but];
    }
}

- (void)showOrHideHomeButtomFun:(UIButton*)but{
    but.selected = !but.selected;
    
    if(but.selected){
        but.imageView.transform = CGAffineTransformMakeRotation(M_PI);
    }
    else{
        but.imageView.transform = CGAffineTransformMakeRotation(0);
    }
    
    [self setShowOrHideBottomButtonsFunBy:but.selected];
}

- (void)setShowOrHideBottomButtonsFunBy:(BOOL)isHide
{
    KWeakSelf
    mainBlock(^{
        self->mueBtn.hidden = isHide;
        self->homeBtn.hidden = isHide;
        self->backBtn.hidden = isHide;
        
        //[weakSelf handleFullScreenClickBottomFunBy:isHide];
    });
}

#pragma mark 处理全屏底部 点击事件无效
//- (void)handleFullScreenClickBottomFunBy:(BOOL)isHide
//{
//    BOOL fullScreenShow = [HWDataManager getBoolWithKey:Consn_player_full_screen_show];
//    
//    if(!fullScreenShow) return;
//    
//    if(_isLan){//横屏
//        
//        if(isHide){//隐藏
//            [self mas_remakeConstraints:^(MASConstraintMaker *make) {
//                make.width.mas_equalTo(60);
//                make.right.mas_equalTo(0);
//                make.top.mas_equalTo(0);
//                make.height.mas_equalTo(60);
//            }];
//        }else{//显示
//            [self mas_remakeConstraints:^(MASConstraintMaker *make) {
//                make.width.mas_equalTo(60);
//                make.right.mas_equalTo(0);
//                make.top.mas_equalTo(0);
//                make.bottom.mas_equalTo(0);
//            }];
//        }
//        
//    }
//    else{//竖屏
//        if(isHide){//隐藏
//            [self mas_remakeConstraints:^(MASConstraintMaker *make) {
//                make.height.mas_equalTo(60.f);
//                make.right.mas_equalTo(0.f);
//                make.bottom.mas_equalTo(0);
//                make.width.mas_equalTo(60.f);
//            }];
//        }else{//显示
//            [self mas_remakeConstraints:^(MASConstraintMaker *make) {
//                make.height.mas_equalTo(60.f);
//                make.right.mas_equalTo(0.f);
//                make.bottom.mas_equalTo(0);
//                make.left.mas_equalTo(0.f);
//            }];
//        }
//    }
//}
@end
